package com.cesgroup.kingkong.web;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.cesgroup.common.utils.ApiResponse;
import com.cesgroup.common.utils.ApiResponseEnum;
import com.cesgroup.common.utils.ApiResultUtil;
import com.cesgroup.kingkong.commons.utils.JwtUtils;
import com.cesgroup.kingkong.core.security.model.JwtUser;
import com.cesgroup.kingkong.entity.IPCheckEntity;
import com.cesgroup.kingkong.interceptor.RequiredPermission;
import com.cesgroup.kingkong.service.IPCheckService;
import com.cesgroup.kingkong.web.bind.annotation.KingkongRestController;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;

/**
 * @program: kyb-search
 * @description: token
 * @author: Wanjianbin
 * @create: 2019-08-27 15:32
 **/
@KingkongRestController
@RequestMapping("/token")
public class TokenController extends BaseServiceController<IPCheckEntity, IPCheckService> {

    @PostMapping("/getToken")
    @RequiredPermission
    public ApiResponse getToken(HttpServletRequest request){
        String ip = ApiResultUtil.getUserIP(request);
        IPCheckEntity ipCheckEntity = this.service.getOne(new QueryWrapper<IPCheckEntity>().eq("ip_address", ip));
        if(ipCheckEntity == null){
            return ApiResultUtil.getApiResponse(null, ApiResponseEnum.AUTH_IP_ERROR);
        }
        JwtUser user = new JwtUser();
        user.setId(ipCheckEntity.getId().toString());
        user.setUserName(ip);
        user.setLoginName(ip);

        String token = JwtUtils.createJwtBySimpleUser(user, 1000*60*60*24, ApiResponseEnum.AUTH_CENTER_SERVICE);
        ipCheckEntity.setToken(token);
        ipCheckEntity.setLastTokenTime(new Date().getTime());
        this.service.updateById(ipCheckEntity);

        return ApiResultUtil.getApiResponse(token, ApiResponseEnum.SUCCESS);
    }

    @RequestMapping("/test")
    public ApiResponse test(){
        return ApiResultUtil.getApiResponse(null, ApiResponseEnum.SUCCESS);
    }
}
